/*-----------------------------------------------------------------------------
	[JoyPad.h]
		pbhLq̂ɕKvȒ`ъ֐̃vg^Cv錾sȂ܂D

	Copyright (C) 2004 Ki

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
**---------------------------------------------------------------------------*/
#ifndef JOY_PAD_H_INCLUDED
#define JOY_PAD_H_INCLUDED

#include <stdio.h>
#include "TypeDefs.h"


enum JoyPadID
{
	JOYPAD_BUTTON_I = 0,
	JOYPAD_BUTTON_II,
	JOYPAD_BUTTON_III,
	JOYPAD_BUTTON_IV,
	JOYPAD_BUTTON_V,
	JOYPAD_BUTTON_VI,
	JOYPAD_BUTTON_SELECT,
	JOYPAD_BUTTON_RUN,
	JOYPAD_BUTTON_UP,
	JOYPAD_BUTTON_RIGHT,
	JOYPAD_BUTTON_DOWN,
	JOYPAD_BUTTON_LEFT
};


/*-----------------------------------------------------------------------------
	֐̃vg^Cv錾sȂ܂D
-----------------------------------------------------------------------------*/
Sint32
JOYPAD_Init();

void
JOYPAD_Deinit();

//Kitaoǉ
void
JOYPAD_Reset();

BOOL
JOYPAD_UseSixButton(
	BOOL	bSixButton);

BOOL
JOYPAD_ConnectMouse(
	BOOL	bConnect);

BOOL
JOYPAD_ConnectMultiTap(
	BOOL	bConnect);

BOOL
JOYPAD_ConnectMB128(
	BOOL	bConnect);


Uint8
JOYPAD_Read(Uint32 regNum);

void
JOYPAD_Write(
	Uint32		regNum,
	Uint8		data);


BOOL
JOYPAD_SaveState(
	FILE*		p);

BOOL
JOYPAD_LoadState(
	FILE*		p);


//Kitaoǉ
BOOL
JOYPAD_GetConnectMultiTap();

//Kitaoǉ
BOOL
JOYPAD_GetConnectSixButton();

//Kitaoǉ
void
JOYPAD_SetSwapSelRun(
	BOOL	bSwapSelRun);

//Kitaoǉ
inline BOOL
JOYPAD_GetSwapSelRun();

//Kitaoǉ
inline void
JOYPAD_ClearPrevUpdateStateLine();


#endif		/* JOY_PAD_H_INCLUDED */
