/******************************************************************************
Ootake
E32rbgJ[ɂΉ邽߁AVCE.cłRGB̕ϊɁARGB333̂܂
  f[^𑗂o悤ɂB
ELύXɔA[h͌ݖBi[h𗘗pĂ\tg
  DDSCREEN.cŎ\j
E352[h́Aʏ̃erʂł̎\͈͂ł336hbgԂ񂾂G
  R[h悤ɂB(Ee8hbgԂ񂸂̓erʏł͌Ȃ)
E544[h̕\ɑΉBi352[hƓlɁAE16hbgԂ񂸂Jb
  g512hbgԂ񂾂GR[hj
Eerʂ̉\𑜓x́AVCERg[WX^̃hbgNbNlŌ
  悤ɂBV[eBOQ[̏cʃ[h@lɓB
E\𑜓xɂłerʗ[̖\̈iсj́AɃXvCg
  ̓FŖ߂悤ɂBiVOQrWAV[Ȃǂ@lɍČj
ETVւ̐\Jnʒuj[Nȃ\tgɂΉBv0.57B

Copyright(C)2006 Kitao Nakamura.
	ŁEpłJȂƂ͕K\[XR[hYtĂB
	̍ۂɎł܂܂̂ŁAЂƂƂm点ƍKłB
	Iȗp͋ւ܂B
	Ƃ́uGNU General Public License(ʌOp_)vɏ܂B

*******************************************************************************
	[VCE.c]
		Implements the VCE.

	Copyright (C) 2004-2005 Ki

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
******************************************************************************/
#include <stdio.h>
#include <malloc.h>
#include "VCE.h"
#include "Screen.h"
#include "VDC.h" //Kitaoǉ
#include "MainBoard.h" //Kitaoǉ

/*
	[DEV NOTE]
	KitaoXVB32rbgJ[ɂΉ邽߁AVCE.cłRGB̕ϊɁARGB333̂܂܃f[^𑗂o悤ɂB
	ݔ[h͖iDDSCREEN̂قɎjB
*/
static Uint8			_DCC;
static Uint16			_ColorTableAddr;
static Sint32			_TvStartPos; //KitaoǉBer̐\Jnʒu
static Sint32			_TvWidth; //KitaoǉBer̐\(𑜓x)

static Uint16			_Palette333[512];
static Uint32			_Palette[512]; //KitaoXVB`掞Ɉ₷悤Uint32Łu0RGBv32rbgŕێB
static Uint16			_ColorLatch;


/*
	[write_palette]

	convert GRB333 --> RGB555 / RGB565
	and write to the palette.

	basic logic:

	Uint8 G = (color & 0x1c0) >> 6;
	Uint8 R = (color & 0x038) >> 3;
	Uint8 B = (color & 0x007) >> 0;

	Rshift = 10;
	Gshift = 5;
	Bshift = 0;

	_Palette[addr]	= R << (Rshift+2);
	_Palette[addr] |= G << (Gshift+2);
	_Palette[addr] |= B << (Bshift+2);
*/
static inline void
write_palette(
	Uint16		addr,
	Uint16		color)
{
	//KitaoXVBu0RGBv32rbgϐ֊i[悤ɂB
	_Palette333[addr] = color;

	Uint32 c=((color & 0x0038)<<13)|((color & 0x01C0)<<2)|(color & 0x0007);

	if (addr == 0x0000) //BGppbgF
	{
		int i;
		for (i = 0x0000; i <= 0x00F0; i += 16)
			_Palette[i] = c;
	}
	else if (addr == 0x0100) //XvCgppbgF
	{
		int i;
		for (i = 0x0100; i <= 0x01F0; i += 16)
			_Palette[i] = c;
	}
	else if ((addr & 0xF) != 0) //FȊOȂ
	{
		_Palette[addr] = c;
	}
}


/*
	[read_palette]

	convert RGB555 / RGB565 --> GRB333

	basic logic:

	Uint8 R = (_Palette[addr] & 0x7c00) >> 10;
	Uint8 G = (_Palette[addr] & 0x03e0) >> 5;
	Uint8 B = (_Palette[addr] & 0x001f) >> 0;

	G >>= 2; R >>=	2; B >>= 2;

	return (G << 6) | (R << 3) | B;

	 0RRR RRGG GGGB BBBB
   & 0111 0011 1001 1100  (0x739c)
   = 0RRR 00GG G00B BB00

	 0000 000G GGRR RBBB
*/
static inline Uint16
read_palette(
	Uint16		addr)
{
	return _Palette333[addr];
}


/*-----------------------------------------------------------------------------
	[VCE_Write]
		ubdւ̏ݓLq܂B
-----------------------------------------------------------------------------*/
void
VCE_Write(
	Uint32		regNum,
	Uint8		data)
{
	switch (regNum & 7)
	{
		case 0: /* Rg[WX^ k */
			// (hbgNbNw肷) 
			_DCC = data & 0x87;
			//KitaoǉBTVʏł̕\ݒ肷
			if ((_DCC & 6) == 6)
				_TvWidth = 512;
			else if ((_DCC & 1) == 1)
				_TvWidth = 336;
			else
				_TvWidth = 256;
			VCE_SetTvStartPos(VDC_GetHDS()); //\JnʒuXV
			return;

		case 1: /* Rg[WX^ g */
			return;

		case 2:	/* J[e[uAhX k */
			_ColorTableAddr &= 0x100;
			_ColorTableAddr |= data;
			return;

		case 3:	/* J[e[uAhX g */
			_ColorTableAddr &= 0xFF;
			_ColorTableAddr |= (data & 1) << 8;
			return;

		case 4:	/* J[e[uf[^Cg k */
			_ColorLatch &= 0x100;
			_ColorLatch |= data;
			return;

		case 5:	/* J[e[uf[^Cg g */
			_ColorLatch &= 0xFF;
			_ColorLatch |= (data & 1) << 8;
			write_palette(_ColorTableAddr, _ColorLatch);
			++_ColorTableAddr;
			_ColorTableAddr &= 0x1FF;
			return;
	}
}


/*-----------------------------------------------------------------------------
	[VCE_Read]
		ubd̓ǂݏoLq܂D
-----------------------------------------------------------------------------*/
Uint8
VCE_Read(
	Uint32		regNum)
{
	Uint8		ret;

	switch (regNum)
	{
		case 4:	/* J[e[uf[^[h k */
			return (Uint8)read_palette(_ColorTableAddr);
		case 5:	/* J[e[uf[^[h g */
			ret = (Uint8)(read_palette(_ColorTableAddr) >> 8) | 0xfe;
			_ColorTableAddr = (_ColorTableAddr + 1) & 0x1ff;
			return ret;
	}

	/* don't return 0xff */
	return 0;
//	return 0xff;
}

void
VCE_EncodeLine(
	Uint32*			pDst,		// out: encoded pixels (RGB333) KitaoXV
	const Uint8*	pSrc,		// in:	palette index (8-bit)
	const Uint8*	pSpBg,		// in:	SP / BG bit array
	Sint32			width)		// in:	scanline width (W̔{Ŏw肷) 
{
//	if (_DCC & 0x80) //KitaoXVBł͔ւ̃GR[h͂Ȃ悤ɂB
//	{
//	}

/*KitaoeXgp
if (WINMAIN_GetBreakTrap())
{
	char s[100];
	sprintf(s,"Kekka=%d, %d, %d, %d",(int)_TvWidth,(int)width,(int)VDC_GetHDS(),(int)_TvStartPos);
	int ok;
	ok = MessageBox(WINMAIN_GetHwnd(),
			s,
			"Test",
			MB_YESNO); //KitaoeXg
	if (ok != IDYES)
		WINMAIN_SetBreakTrap(FALSE);
}
*/

	//KitaoXVBv0.57
	pSrc += _TvStartPos;
	pSpBg += _TvStartPos;
	if (width > _TvWidth)
		width = _TvWidth / 8;
	else
		width /= 8;

	Uint32* pdwSpBg = (Uint32*)pSpBg;

	while (width-- > 0)
	{
		*pdwSpBg++ &= 0x01010101;
		*pdwSpBg++ &= 0x01010101;
		
		*pDst++ = _Palette[*pSrc++|(*pSpBg++<<8)];//KitaoXV
		*pDst++ = _Palette[*pSrc++|(*pSpBg++<<8)];
		*pDst++ = _Palette[*pSrc++|(*pSpBg++<<8)];
		*pDst++ = _Palette[*pSrc++|(*pSpBg++<<8)];
		*pDst++ = _Palette[*pSrc++|(*pSpBg++<<8)];
		*pDst++ = _Palette[*pSrc++|(*pSpBg++<<8)];
		*pDst++ = _Palette[*pSrc++|(*pSpBg++<<8)];
		*pDst++ = _Palette[*pSrc++|(*pSpBg++<<8)];
	}
}


BOOL
VCE_IsHiresolutionMode()
{
	return ((_DCC & 6) == 6);
}


//KitaoǉBerʂ̉\𑜓xihbgNbNŌ܂jԂB
inline Sint32
VCE_GetTvWidth()
{
	return _TvWidth;
}


//KitaoǉBerʂ̐\Jnʒuݒ肷B
inline void
VCE_SetTvStartPos(
	Uint8	data)
{
	if (_TvWidth == 256)
		_TvStartPos = (2 - data) * 8; //256̏ꍇقƂǂdata=2
	else if (_TvWidth == 336)
		_TvStartPos = (4 - data) * 8; //352̏ꍇAقƂǂdata=3ōE8hbgJbgBNCYal̖](data=2)͍16hbgJbgBVn炤(data=3)͉368ō8hbgE24hbgJbg336hbgƂďóB
	else //(_TvWidth == 512)
		_TvStartPos = (11 - data) * 8; //512(V[bNz[Y)̏ꍇdata=11B544[h̏ꍇdata=8(TVX|[coXP̑II)B
	if (VDC_GetScreenWidth() < _TvWidth)
		_TvStartPos -= (_TvWidth - VDC_GetScreenWidth()) * 2;
	if (_TvStartPos < 0) //VCẼhbgNbNScreenWidthύXꂽꍇɋN蓾BTVX|[coXPŊmFB
		_TvStartPos = 0;
}


//KitaoǉBXvCg̓F32rbgJ[ŕԂB
inline Uint32
VCE_GetSpColor0100()
{
	return _Palette[0x0100]; //XvCg̓F
}


/*-----------------------------------------------------------------------------
	[VCE_Init]
		ubd܂B
-----------------------------------------------------------------------------*/
Sint32
VCE_Init()
{
	int	i;

	for (i = 0; i < 512; ++i)
	{
		_Palette333[i] = 0x1ff;
		_Palette[i] = 0x00070707; //KitaoXVB
	}

	_DCC = 0;
	_ColorTableAddr = 0;
	_ColorLatch = 0;
	_TvStartPos = 0; //Kitaoǉ
	_TvWidth = 256; //Kitaoǉ

	return 0;
}


// save variable
#define SAVE_V(V)	if (fwrite(&V, sizeof(V), 1, p) != 1)	return FALSE
#define LOAD_V(V)	if (fread(&V, sizeof(V), 1, p) != 1)	return FALSE
// save array
#define SAVE_A(A)	if (fwrite(A, sizeof(A), 1, p) != 1)	return FALSE
#define LOAD_A(A)	if (fread(A, sizeof(A), 1, p) != 1)		return FALSE
/*-----------------------------------------------------------------------------
	[SaveState]
		Ԃt@Cɕۑ܂B 
-----------------------------------------------------------------------------*/
BOOL
VCE_SaveState(
	FILE*		p)
{
	if (p == NULL)
		return FALSE;

	SAVE_V(_DCC);
	SAVE_V(_ColorTableAddr);
	SAVE_V(_TvStartPos); //KitaoǉB0.57
	SAVE_V(_TvWidth); //KitaoǉB0.57

	SAVE_A(_Palette333);
	SAVE_A(_Palette);

	SAVE_V(_ColorLatch);

	return TRUE;
}


/*-----------------------------------------------------------------------------
	[LoadState]
		Ԃt@Cǂݍ݂܂B 
-----------------------------------------------------------------------------*/
BOOL
VCE_LoadState(
	FILE*		p)
{
	if (p == NULL)
		return FALSE;

	LOAD_V(_DCC);
	LOAD_V(_ColorTableAddr);
	if (MAINBOARD_GetStateVersion() >= 3) //KitaoǉBv0.57ȍ~̃Z[ut@CȂ
	{
		LOAD_V(_TvStartPos);
		LOAD_V(_TvWidth);
	}

	LOAD_A(_Palette333);
	LOAD_A(_Palette);

	LOAD_V(_ColorLatch);

	return TRUE;
}

#undef SAVE_V
#undef SAVE_A
#undef LOAD_V
#undef LOAD_A
