/*-----------------------------------------------------------------------------
	{WinMain.h]

	Copyright (C) 2004 Ki

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-----------------------------------------------------------------------------*/
#ifndef WINMAIN_H_INCLUDED
#define WINMAIN_H_INCLUDED

#include "TypeDefs.h"


//KitaoǉBMAINCAPTION͑g悤ɂ̂łŒ`
#ifdef DEBUGBUILD
#define MAINCAPTION		"Ootake DEBUG BUILD " __DATE__
#else
#define MAINCAPTION		"Ootake"
#endif


enum UserDefinedWM
{
	WM_SET_FULLSCREEN_WS = WM_APP,
	WM_SET_NORMAL_WS,
};

/* j[R}h 100 ` */
enum MenuCommand
{
	WM_TRACE_1_FRAME = 100,
	WM_TRACE_10_FRAME,
	WM_TRACE_100_FRAME,
	WM_OPEN_FILE,
	WM_RESET_EMULATOR,
	WM_RUN_EMULATOR,
	WM_STOP_EMULATOR,
	WM_SAVE_STATE,
	WM_SAVE_STATE_1, //Kitaoǉ
	WM_SAVE_STATE_2, //Kitaoǉ
	WM_SAVE_STATE_3, //Kitaoǉ
	WM_SAVE_STATE_4, //Kitaoǉ
	WM_SAVE_STATE_5, //Kitaoǉ
	WM_SAVE_STATE_6, //Kitaoǉ
	WM_SAVE_STATE_7, //Kitaoǉ
	WM_SAVE_STATE_8, //Kitaoǉ
	WM_SAVE_STATE_9, //Kitaoǉ
	WM_LOAD_STATE,
	WM_LOAD_STATE_P, //Kitaoǉ
	WM_LOAD_STATE_1, //Kitaoǉ
	WM_LOAD_STATE_2, //Kitaoǉ
	WM_LOAD_STATE_3, //Kitaoǉ
	WM_LOAD_STATE_4, //Kitaoǉ
	WM_LOAD_STATE_5, //Kitaoǉ
	WM_LOAD_STATE_6, //Kitaoǉ
	WM_LOAD_STATE_7, //Kitaoǉ
	WM_LOAD_STATE_8, //Kitaoǉ
	WM_LOAD_STATE_9, //Kitaoǉ
	WM_FOLDER_STATE, //Kitaoǉ
	WM_RECORD_GAMEPLAY,
	WM_PLAYBACK_GAMEPLAY,
	WM_FOLDER_GAMEPLAY, //Kitaoǉ

	WM_SCREEN_X1,
	WM_SCREEN_X2,
	WM_SCREEN_X3,
	WM_SCREEN_X4,

	WM_SCREEN_NONESTRETCHED, //Kitaoǉ
	WM_SCREEN_STRETCHED,
	WM_SCREEN_VERTICAL, //Kitaoǉ

	WM_INPUT_TWO_BUTTON_PAD,
	WM_INPUT_SIX_BUTTON_PAD,
	WM_INPUT_MOUSE,
	WM_INPUT_MULTI_TAP,
	WM_INPUT_MB128,
	WM_INPUT_SWAP_SELRUN, //Kitaoǉ
	WM_INPUT_TURBO_1, //Kitaoǉ
	WM_INPUT_TURBO_2, //Kitaoǉ
	WM_INPUT_TURBO_RUN, //Kitaoǉ
	WM_INPUT_TURBO_HIGH, //Kitaoǉ
	WM_INPUT_TURBO_MIDDLE, //Kitaoǉ
	WM_INPUT_TURBO_LOW, //Kitaoǉ

	WM_INPUT_CONFIGURE_PAD1,
	WM_INPUT_CONFIGURE_PAD2,
	WM_INPUT_CONFIGURE_PAD3,
	WM_INPUT_CONFIGURE_PAD4,
	WM_INPUT_CONFIGURE_PAD5,

	WM_SCREEN_FULLSCREEN,
	WM_SCREEN_SCANLINED,
	WM_SCREEN_HWACCEL,
	WM_SCREEN_SYNC_VBLANK,
	WM_SCREEN_FULL16BITCOLOR, //Kitaoǉ
	WM_SCREEN_FULL32BITCOLOR, //Kitaoǉ
	WM_SCREEN_STARTWINDOW, //Kitaoǉ
	WM_SCREEN_STARTFULL, //Kitaoǉ

	WM_AUDIO_SR11025,
	WM_AUDIO_SR22050,
	WM_AUDIO_SR32000,
	WM_AUDIO_SR44100,
	WM_AUDIO_SR48000,
	WM_AUDIO_SR64000,
	WM_AUDIO_SR88200,		/* not supported */
	WM_AUDIO_SR96000,		/* not supported */

	WM_AUDIO_SB1024, //KitaoXV
	WM_AUDIO_SB1536,
	WM_AUDIO_SB1792,
	WM_AUDIO_SB2048,
	WM_AUDIO_SB2304,
	WM_AUDIO_SB2560,
	WM_AUDIO_SB3072,
	WM_AUDIO_SB3584,
	WM_AUDIO_SB4096,

	WM_AUDIO_SETVOLUME,
	WM_AUDIO_DEFAULTVOLUME, //Kitaoǉ
	WM_VOLUME_NORMAL, //Kitaoǉ
	WM_VOLUME_HALF, //Kitaoǉ
	WM_VOLUME_QUARTER, //Kitaoǉ
	WM_VOLUME_MUTE, //Kitaoǉ
	WM_VOLUME_NORMALBUFFER, //Kitaoǉ
	WM_VOLUME_BIGBUFFER, //Kitaoǉ
	WM_VOLUME_MOSTBUFFER, //Kitaoǉ

	WM_INFO_MANUENGLISH, //Kitaoǉ
	WM_INFO_MANUJAPANESE, //Kitaoǉ
	WM_INFO_README, //Kitaoǉ
	WM_INFO_HOMEPAGE, //Kitaoǉ
	WM_INFO_VERSION, //Kitaoǉ

	WM_DEVICE_SYSTEMCARD, //Kitaoǉ
	WM_DEVICE_CD0, //Kitaoǉ
	WM_DEVICE_CD1, //Kitaoǉ
	WM_DEVICE_CD2, //Kitaoǉ
	WM_DEVICE_CD3, //Kitaoǉ
	WM_DEVICE_CD4, //Kitaoǉ
	WM_DEVICE_CD5, //Kitaoǉ
	WM_DEVICE_CD6, //Kitaoǉ
	WM_DEVICE_CD7, //Kitaoǉ
	WM_DEVICE_CD8, //Kitaoǉ
	WM_DEVICE_CD9, //Kitaoǉ
	WM_DEVICE_CDDABUFFER1, //Kitaoǉ
	WM_DEVICE_CDDABUFFER2, //Kitaoǉ
	WM_DEVICE_CDDABUFFER3, //Kitaoǉ
	WM_DEVICE_CDDABUFFER4, //Kitaoǉ
	WM_DEVICE_CDDABUFFER5, //Kitaoǉ
	WM_DEVICE_CDDABUFFER6, //Kitaoǉ
	WM_DEVICE_CDDABUFFER7, //Kitaoǉ
	WM_DEVICE_CDDABUFFER8, //Kitaoǉ
	WM_DEVICE_CDDABUFFER9, //Kitaoǉ

	WM_POWER_FULLSPEED, //Kitaoǉ
	WM_POWER_POWERSAVING, //Kitaoǉ

	WM_SPEED_P0, //Kitaoǉ
	WM_SPEED_P1, //Kitaoǉ
	WM_SPEED_P2, //Kitaoǉ
	WM_SPEED_P3, //Kitaoǉ
	WM_SPEED_P4, //Kitaoǉ
	WM_SPEED_P5, //Kitaoǉ
	WM_SPEED_P6, //Kitaoǉ
	WM_SPEED_TURBO, //Kitaoǉ
	WM_SPEED_FASTCD, //Kitaoǉ
	WM_SPEED_HELP, //Kitaoǉ

	WM_RASTERTIMING_EARLY, //Kitaoǉ
	WM_RASTERTIMING_MIDDLE, //Kitaoǉ
	WM_RASTERTIMING_LATE, //Kitaoǉ

	WM_SPRITEOVER, //Kitaoǉ

	WM_EXIT,

	WM_SAVE_BMP,
};


extern int	__main__(int argc, char** argv);


const HINSTANCE	WINMAIN_GetHInstance();

inline const HWND
WINMAIN_GetHwnd();

void
WINMAIN_SetFullScreenWindow(
	Sint32		width,
	Sint32		height);
void
WINMAIN_SetNormalWindow(
	Sint32		width,
	Sint32		height);

void
WINMAIN_SetCaption(
	const char*		pCaption);

Uint32
WINMAIN_ShowCursor(
	BOOL		bShow);

void
WINMAIN_GetMousePos(
	Sint32*		x,
	Sint32*		y);


//KitaoǉBfobOp
void
WINMAIN_SetBreakTrap(
	BOOL bBrakTrap);

//KitaoǉBfobOp
BOOL
WINMAIN_GetBreakTrap();


#endif /* WINMAIN_H_INCLUDED */
